package com.njcn.bpm.service.impl;

import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.njcn.bpm.enums.BpmModelFormTypeEnum;
import com.njcn.bpm.enums.BpmResponseEnum;
import com.njcn.bpm.pojo.dto.BpmModelMetaInfoRespDTO;
import com.njcn.bpm.pojo.param.BpmModelParam;
import com.njcn.bpm.pojo.po.BpmForm;
import com.njcn.bpm.service.IBpmFormService;
import com.njcn.bpm.service.IBpmModelService;
import com.njcn.bpm.service.IBpmProcessDefinitionService;
import com.njcn.bpm.strategy.BpmTaskCandidateInvoker;
import com.njcn.bpm.utils.*;
import com.njcn.common.pojo.exception.BusinessException;
import com.njcn.web.factory.PageFactory;
import lombok.extern.slf4j.Slf4j;
import org.flowable.bpmn.model.BpmnModel;
import org.flowable.bpmn.model.StartEvent;
import org.flowable.bpmn.model.UserTask;
import org.flowable.common.engine.impl.db.SuspensionState;
import org.flowable.engine.ProcessEngineConfiguration;
import org.flowable.engine.RepositoryService;
import org.flowable.engine.repository.Model;
import org.flowable.engine.repository.ModelQuery;
import org.flowable.engine.repository.ProcessDefinition;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.util.ObjectUtils;
import org.springframework.validation.annotation.Validated;

import javax.annotation.Resource;
import java.util.List;
import java.util.Objects;


/**
 * Flowable流程模型实现
 * 主要进行 Flowable {@link Model} 的维护
 *
 * @author yunlongn
 * @author hongawen
 * @author jason
 */
@Service
@Validated
@Slf4j
public class BpmModelServiceImpl implements IBpmModelService {

    @Resource
    private RepositoryService repositoryService;
    @Resource
    private IBpmProcessDefinitionService processDefinitionService;
    @Resource
    private IBpmFormService bpmFormService;
    @Resource
    private BpmTaskCandidateInvoker taskCandidateInvoker;

    @Override
    public Page<Model> getModelPage(BpmModelParam.BpmModelQueryParam bpmModelQueryParam) {
        ModelQuery modelQuery = repositoryService.createModelQuery();
        if (StrUtil.isNotBlank(bpmModelQueryParam.getKey())) {
            modelQuery.modelKey(bpmModelQueryParam.getKey());
        }
        if (StrUtil.isNotBlank(bpmModelQueryParam.getName())) {
            // 模糊匹配
            modelQuery.modelNameLike("%" + bpmModelQueryParam.getName() + "%");
        }
        if (StrUtil.isNotBlank(bpmModelQueryParam.getCategory())) {
            modelQuery.modelCategory(bpmModelQueryParam.getCategory());
        }
        // 执行查询
        long count = modelQuery.count();
        if (count == 0) {
            return new Page<>();
        }
        int offset = PageFactory.getPageSize(bpmModelQueryParam) * (PageFactory.getPageNum(bpmModelQueryParam) - 1);
        List<Model> models = modelQuery
                .modelTenantId(ProcessEngineConfiguration.NO_TENANT_ID)
                .orderByCreateTime().desc()
                .listPage(offset, PageFactory.getPageSize(bpmModelQueryParam));

        Page<Model> page = new Page<>();
        page.setRecords(models);
        page.setTotal(count);
        page.setSize(PageFactory.getPageSize(bpmModelQueryParam));
        page.setCurrent(PageFactory.getPageNum(bpmModelQueryParam));
        return page;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public String createModel(BpmModelParam bpmModelParam, String bpmnXml) {
        if (!ValidationUtils.isXmlNCName(bpmModelParam.getKey())) {
            throw new BusinessException(BpmResponseEnum.BPM_XML_ERROR);
        }
        // 校验流程标识已经存在
        Model keyModel = getModelByKey(bpmModelParam.getKey());
        if (keyModel != null) {
            throw new BusinessException(BpmResponseEnum.BPM_MODEL_REPEAT);
        }
        // 创建流程定义
        Model model = repositoryService.newModel();
        BpmModelConvert.INSTANCE.copyToCreateModel(model, bpmModelParam);
        model.setTenantId(FlowableUtils.getTenantId());
        // 保存流程定义
        repositoryService.saveModel(model);
        // 保存 BPMN XML
        saveModelBpmnXml(model, bpmnXml);
        return model.getId();
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void updateModel(BpmModelParam.BpmModelUpdateParam updateParam) {
        // 校验流程模型存在
        Model model = getModel(updateParam.getId());
        if (model == null) {
            throw new BusinessException(BpmResponseEnum.BPM_MODEL_NOT_EXIST);
        }
        // 修改流程定义
        BpmModelConvert.INSTANCE.copyToUpdateModel(model, updateParam);
        // 更新模型
        repositoryService.saveModel(model);
        // 更新 BPMN XML
        saveModelBpmnXml(model, updateParam.getBpmnXml());
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void deployModel(String id) {
        // 1.1 校验流程模型存在
        Model model = getModel(id);
        if (ObjectUtils.isEmpty(model)) {
            throw new BusinessException(BpmResponseEnum.BPM_MODEL_NOT_EXIST);
        }
        // 1.2 校验流程图
        byte[] bpmnBytes = getModelBpmnXML(model.getId());
        validateBpmnXml(bpmnBytes);
        // 1.3 校验表单已配
        BpmModelMetaInfoRespDTO metaInfo = JsonUtils.parseObject(model.getMetaInfo(), BpmModelMetaInfoRespDTO.class);
        BpmForm form = validateFormConfig(metaInfo);

        // 1.4 校验任务分配规则已配置
        taskCandidateInvoker.validateBpmnConfig(bpmnBytes);

        // 2.1 创建流程定义
        String definitionId = processDefinitionService.createProcessDefinition(model, metaInfo, bpmnBytes, form);

        // 2.2 将老的流程定义进行挂起。也就是说，只有最新部署的流程定义，才可以发起任务。
        updateProcessDefinitionSuspended(model.getDeploymentId());

        // 2.3 更新 model 的 deploymentId，进行关联
        ProcessDefinition definition = processDefinitionService.getProcessDefinition(definitionId);
        model.setDeploymentId(definition.getDeploymentId());
        repositoryService.saveModel(model);
    }

    private void validateBpmnXml(byte[] bpmnBytes) {
        BpmnModel bpmnModel = BpmnModelUtils.getBpmnModel(bpmnBytes);
        if (bpmnModel == null) {
            throw new BusinessException(BpmResponseEnum.BPM_MODEL_NOT_EXIST);
        }
        // 1. 没有 StartEvent
        StartEvent startEvent = BpmnModelUtils.getStartEvent(bpmnModel);
        if (startEvent == null) {
            throw new BusinessException(BpmResponseEnum.BPM_START_EVENT_NOT_EXIST);
        }
        // 2. 校验 UserTask 的 name 都配置了
        List<UserTask> userTasks = BpmnModelUtils.getBpmnModelElements(bpmnModel, UserTask.class);
        UserTask userTask1 = userTasks.get(0);
        userTask1.getName();
        userTasks.forEach(userTask -> {
            if (StrUtil.isEmpty(userTask.getName())) {
                throw new BusinessException(BpmResponseEnum.MODEL_DEPLOY_FAIL_BPMN_USER_TASK_NAME_NOT_EXISTS);
            }
        });
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void deleteModel(String id) {
        // 校验流程模型存在
        Model model = getModel(id);
        if (model == null) {
            throw new BusinessException(BpmResponseEnum.BPM_MODEL_NOT_EXIST);
        }
        // 执行删除
        repositoryService.deleteModel(id);
        // 禁用流程定义
        updateProcessDefinitionSuspended(model.getDeploymentId());
    }

    @Override
    public void updateModelState(String id, Integer state) {
        // 1.1 校验流程模型存在
        Model model = getModel(id);
        if (model == null) {
            throw new BusinessException(BpmResponseEnum.BPM_MODEL_NOT_EXIST);
        }
        // 1.2 校验流程定义存在
        ProcessDefinition definition = processDefinitionService.getProcessDefinitionByDeploymentId(model.getDeploymentId());
        if (definition == null) {
            throw new BusinessException(BpmResponseEnum.PROCESS_DEFINITION_NOT_EXISTS);
        }

        // 2. 更新状态
        processDefinitionService.updateProcessDefinitionState(definition.getId(), state);
    }

    @Override
    public BpmnModel getBpmnModelByDefinitionId(String processDefinitionId) {
        return repositoryService.getBpmnModel(processDefinitionId);
    }

    /**
     * 校验流程表单已配置
     *
     * @param metaInfo 流程模型元数据
     * @return 表单配置
     */
    private BpmForm validateFormConfig(BpmModelMetaInfoRespDTO metaInfo) {
        if (metaInfo == null || metaInfo.getFormType() == null) {
            throw new BusinessException(BpmResponseEnum.MODEL_DEPLOY_FAIL_FORM_NOT_CONFIG);
        }
        // 校验表单存在
        if (Objects.equals(metaInfo.getFormType(), BpmModelFormTypeEnum.NORMAL.getType())) {
            if (metaInfo.getFormId() == null) {
                throw new BusinessException(BpmResponseEnum.MODEL_DEPLOY_FAIL_FORM_NOT_CONFIG);
            }
            BpmForm form = bpmFormService.getById(metaInfo.getFormId());
            if (form == null) {
                throw new BusinessException(BpmResponseEnum.FORM_NOT_EXISTS);
            }
            return form;
        } else {
            if (StrUtil.isEmpty(metaInfo.getFormCustomCreatePath()) || StrUtil.isEmpty(metaInfo.getFormCustomViewPath())) {
                throw new BusinessException(BpmResponseEnum.MODEL_DEPLOY_FAIL_FORM_NOT_CONFIG);
            }
            return null;
        }
    }

    private void saveModelBpmnXml(Model model, String bpmnXml) {
        if (StrUtil.isEmpty(bpmnXml)) {
            return;
        }
        repositoryService.addModelEditorSource(model.getId(), StrUtil.utf8Bytes(bpmnXml));
    }

    /**
     * 挂起 deploymentId 对应的流程定义
     * <p>
     * 注意：这里一个 deploymentId 只关联一个流程定义
     *
     * @param deploymentId 流程发布Id
     */
    private void updateProcessDefinitionSuspended(String deploymentId) {
        if (StrUtil.isEmpty(deploymentId)) {
            return;
        }
        ProcessDefinition oldDefinition = processDefinitionService.getProcessDefinitionByDeploymentId(deploymentId);
        if (oldDefinition == null) {
            return;
        }
        processDefinitionService.updateProcessDefinitionState(oldDefinition.getId(), SuspensionState.SUSPENDED.getStateCode());
    }

    private Model getModelByKey(String key) {
        return repositoryService.createModelQuery().modelKey(key).singleResult();
    }

    @Override
    public Model getModel(String id) {
        return repositoryService.getModel(id);
    }

    @Override
    public byte[] getModelBpmnXML(String id) {
        return repositoryService.getModelEditorSource(id);
    }

}
